#include <oxstd.oxh>
#include <oxdraw.oxh>
#include <oxprob.oxh>
#include <oxfloat.oxh>
#import <maximize>

#include "Misc.ox"
#include "Base.ox"
#include "StandardizedKernelEstimator2.ox"
#include "Components.ox"

main () {
	decl T = 2000;
	decl replications = 1000;
	decl K = 1000; // how much data to use for estimation

	decl truevol = Vol_Stoch(T);
		decl data = rann(1,T) .* truevol;
		decl initpar = <0, 0.5, 0.3, 0.9>;
		decl inittpar = initpar ~ <5>;
		decl initgarchpar = <0, 1.5, 0.05, 0.9>;
		decl inittgarchpar = initgarchpar ~ <5>;

		decl par1 = initpar, code1,	ft1, epst1,
			par2 = initgarchpar, code2, volsq2, epst2,
			par3 = inittpar, code3,	ft3, epst3,
			par4 = inittgarchpar, code4, volsq4, epst4,
			par5 = initpar, code5, ft5, epst5,
			par6 = initgarchpar, code6, volsq6, epst6;

		code1 = GAS_QMLE(data, K, &par1, &ft1, &epst1);		
		code2 = GARCH_QMLE(data, K, &par2, &volsq2, &epst2);
		code3 = GAS_t(data, K, &par3, &ft3, &epst3);
		code4 = GARCH_t(data, K, &par4, &volsq4, &epst4);

		DrawMatrix(0, sqrt(volsq2) | exp(ft1/2), 0, 0, 1); ShowDrawWindow();
}