from __future__ import print_function
import os

# data

table1 = [
    {
        'name': 'Normal',
        'MLE': 'GAS_QMLE',
        'DGP': 'GASgenerator_Normal(T, mu, omega, alpha, beta)'
    },
    {
        'name': 't3',
        'MLE': 'GAS_t3',
        'DGP': 'GASgenerator_t(T, mu, omega, alpha, beta, 3)'
    },
    {
        'name': 't5',
        'MLE': 'GAS_t5',
        'DGP': 'GASgenerator_t(T, mu, omega, alpha, beta, 5)'
    },
    {
        'name': 'MN',
        'MLE': 'GAS_MN',
        'DGP': 'GASgenerator_MN(T, mu, omega, alpha, beta)'
    },
]

table2vols = ['Sine', 'LongRegimes', 'ShortRegimes', 'Bursts']
table2 = [
    {
        'name': 'Normal',
        'ran': 'rann(1, T)',
        'MLE': 'GAS_QMLE'
    },
    {
        'name': 't3',
        'ran': 'rannormt(1, T, 3)',
        'MLE': 'GAS_t3'
    },
    {
        'name': 't5',
        'ran': 'rannormt(1, T, 5)',
        'MLE': 'GAS_t5'
    },
    {
        'name': 'MN',
        'ran': 'ranchimix(1, T)',
        'MLE': 'GAS_MN'
    },
]

table3 = [
    {
        'name': 'Normal',
        'ran': 'rann(1, T)',
    },
    {
        'name': 't3',
        'ran': 'rannormt(1, T, 3)',
    },
    {
        'name': 't5',
        'ran': 'rannormt(1, T, 5)',
    },
    {
        'name': 'MN',
        'ran': 'ranchimix(1, T)',
    },
]

# logic

# 1

bash = open('run1.sh', 'w')
bash.write("#!/bin/bash\n")
bash.write("export MAXCNT=8\n")
for d in table1:
    filename = 'Table1_' + d['name'] + '.ox'
    f1 = open('Table1.ox',  'r')
    f2 = open(filename, 'w')
    for line in f1:
        f2.write(line.replace('%NAME%', d['name']).replace('%MLE%', d['MLE']).replace('%DGP%', d['DGP']))
    f1.close()
    f2.close()

    bash.write('oxl '+filename+' >/dev/null &\ncheckcpuload\n')
bash.write('wait')
bash.close()

# 2

bash = open('run2.sh', 'w')
bash.write("#!/bin/bash\n")
bash.write("export MAXCNT=8\n")

for vol in table2vols:
    for d in table2:
        filename = 'Table2_' + d['name'] + '_' + vol + '.ox'
        f1 = open('Table2.ox',  'r')
        f2 = open(filename, 'w')
        for line in f1:
            f2.write(line.replace('%NAME%', d['name']).replace('%MLE%', d['MLE']).replace('%RAN%', d['ran']).replace('%VOL%', vol))
        f1.close()
        f2.close()
        
        bash.write('oxl '+filename+' >/dev/null &\ncheckcpuload\n')

bash.write('wait')
bash.close()

# 3

bash = open('run3.sh', 'w')
bash.write("#!/bin/bash\n")
bash.write("export MAXCNT=8\n")

for d in table2:
    filename = 'Table3_' + d['name'] + '.ox'
    f1 = open('Table3.ox',  'r')
    f2 = open(filename, 'w')
    for line in f1:
        f2.write(line.replace('%NAME%', d['name']).replace('%RAN%', d['ran']))
    f1.close()
    f2.close()
    
    bash.write('oxl '+filename+' >/dev/null &\ncheckcpuload\n')

bash.write('wait')
bash.close()

print('Done.')


